aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--op_guide/garage/README.md1
-rw-r--r--op_guide/garage/backup.sh65
-rw-r--r--op_guide/restic/README.md (renamed from op_guide/backup_minio/README.md)0
-rw-r--r--op_guide/stolon/nomad_full_backup.md2
4 files changed, 67 insertions, 1 deletions
diff --git a/op_guide/garage/README.md b/op_guide/garage/README.md
new file mode 100644
index 0000000..44fda62
--- /dev/null
+++ b/op_guide/garage/README.md
@@ -0,0 +1 @@
+Not very generic currently, check the backup.sh script
diff --git a/op_guide/garage/backup.sh b/op_guide/garage/backup.sh
new file mode 100644
index 0000000..2ff18cd
--- /dev/null
+++ b/op_guide/garage/backup.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+
+cd $(dirname $0)
+
+if [ "$(hostname)" != "io" ]; then
+ echo "Please run this script on io"
+ exit 1
+fi
+
+if [ ! -d "buckets" ]; then
+ btrfs subvolume create $(pwd)/buckets
+fi
+
+
+AK=$1
+SK=$2
+
+function gctl {
+ docker exec garage /garage $@
+}
+
+gctl status
+BUCKETS=$(gctl bucket list | tail -n +2 | cut -d " " -f 3 | cut -d "," -f 1)
+
+for BUCKET in $BUCKETS; do
+ case $BUCKET in
+ *backup*)
+ echo "Skipping $BUCKET (not doing backup of backup)"
+ ;;
+ *cache*)
+ echo "Skipping $BUCKET (not doing backup of cache)"
+ ;;
+ *)
+ echo "Backing up $BUCKET"
+
+ if [ ! -d $(pwd)/buckets/$BUCKET ]; then
+ mkdir $(pwd)/buckets/$BUCKET
+ fi
+
+ gctl bucket allow --key $AK --read $BUCKET
+ rclone sync --s3-endpoint http://localhost:3900 \
+ --s3-access-key-id $AK \
+ --s3-secret-access-key $SK \
+ --s3-region garage \
+ --s3-force-path-style \
+ --transfers 32 \
+ --fast-list \
+ --stats-one-line \
+ --stats 10s \
+ --stats-log-level NOTICE \
+ :s3:$BUCKET $(pwd)/buckets/$BUCKET
+ ;;
+ esac
+done
+
+# Remove duplicates
+#duperemove -dAr $(pwd)/buckets
+
+if [ ! -d "$(pwd)/snapshots" ]; then
+ mkdir snapshots
+fi
+
+SNAPSHOT=$(pwd)/snapshots/buckets-$(date +%F)
+echo "Making snapshot: $SNAPSHOT"
+btrfs subvolume snapshot $(pwd)/buckets $SNAPSHOT
diff --git a/op_guide/backup_minio/README.md b/op_guide/restic/README.md
index a7576c0..a7576c0 100644
--- a/op_guide/backup_minio/README.md
+++ b/op_guide/restic/README.md
diff --git a/op_guide/stolon/nomad_full_backup.md b/op_guide/stolon/nomad_full_backup.md
index 574043a..2fb5822 100644
--- a/op_guide/stolon/nomad_full_backup.md
+++ b/op_guide/stolon/nomad_full_backup.md
@@ -1,4 +1,4 @@
-Start by following ../backup-minio
+Start by following ../restic
## Garbage collect old backups